#ifndef SOCKLIB_H
#define SOCKLIB_H

#include <sys/types.h>
#include <sys/signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>

#define RECEIVER_PORT(x) (x)
#define SENDER_PORT(x) ((x)+1)

#ifdef LOSSTEST
int loseSendPacket();
void loseRecvPacket(int s);
void setWriteLoss(char *l);
void setReadLoss(char *l);
void setReadSwap(char *l);
void srandomTime(int printSeed);
int RecvMsg(int s, struct msghdr *msg, int flags);
#endif


void doAutoRateLimit(int socket, int dir, int qsize, int size);

int makeSockAddr(char *hostname, short port, struct sockaddr *addr);

int getMyAddress(int s, char *ifname, struct sockaddr *addr);
int getBroadCastAddress(int s, char *ifname, struct sockaddr *addr, 
			short port);
int getMcastAllAddress(int s, char *ifname, struct sockaddr *addr, 
		       char *address, short port);


int doSend(int s, void *message, size_t len, struct sockaddr *to);
int doReceive(int s, void *message, size_t len,
	      struct sockaddr *from, int portBase);

void printMyIp(char *ifname, int s);


int makeSocket(int port);

int setSocketToBroadcast(int socket);
int setTtl(int socket, int ttl);

int mcastListen(int, char *,struct sockaddr *);
int setMcastDestination(int,char *,struct sockaddr *);

int getCurrentQueueLength(int socket);
int getSendBuf(int socket);
unsigned int getRcvBuf(int socket);

#define SEND(s, msg, to) \
	doSend(s, &msg, sizeof(msg), &to)

#define RECV(s, msg, from, portBase ) \
	doReceive((s), &msg, sizeof(msg), &from, (portBase) )

#define BCAST_CONTROL(s, msg) \
	doSend(s, &msg, sizeof(msg), &net_config->controlMcastAddr)

unsigned short getPort(struct sockaddr *addr);
void setPort(struct sockaddr *addr, unsigned short port);
char *getIpString(struct sockaddr *addr, char *buffer);
int ipIsEqual(struct sockaddr *left, struct sockaddr *right);
int ipIsZero(struct sockaddr *ip);

void clearIp(struct sockaddr *addr);
void setIpFromString(struct sockaddr *addr, char *ip);

void copyIpFrom(struct sockaddr *dst, struct sockaddr *src);

void getDefaultMcastAddress(int socket, char *net_if, struct sockaddr *mcast);

void copyToMessage(unsigned char *dst, struct sockaddr *src);
void copyFromMessage(struct sockaddr *dst, unsigned char *src);

int isAddressEqual(struct sockaddr *a, struct sockaddr *b);
#endif
